"use_strict";
$(function(){
function add_selected_fields()
{
	var o=$('#selected_fields optgroup#order-fields'),p=$('#selected_fields optgroup#product-fields');
	$('#available_fields option:selected').each(function(){
		var a=$(this),b;
		if((b=$('#selected_fields option[data-orig-num='+a.val()+']')).length === 0){
			b=a.clone();
			if(dbid === 3){if(a.val() >= 200){b.appendTo(p);}else{b.appendTo(o);}}
			else{b.appendTo('#selected_fields')}
		}//else{b.appendTo(b.parent())}
	});
}

function remove_selected_fields(){$('#selected_fields option:selected').remove();}

function move_field(fields_list, incr){
	function move_it(fields_list, incr){var o=$('#'+fields_list+' option:selected');if(incr>0){o=$(o.get().reverse());}o.each(function(){var a=$(this),b=a.prev(),c=a.next();if(incr<0){if(b.length === 1 && !b.prop('selected')){a.insertBefore(b);}}else if(incr>0){if(c.length === 1 && !c.prop('selected')){a.insertAfter(c);}}});}
	if(document.querySelector('#selected_fields optgroup#order-fields') !== undefined){move_it('order-fields', incr);move_it('product-fields', incr);}else{move_it(fields_list, incr);}
}

function change_field_name()
{
	var field_label=document.getElementById('field_label').value.replace(/["\'\\.]+/g,'');
	$('#selected_fields option:selected').get().forEach(function(e){
		var orig_name = e.dataset.origName, num = e.dataset.origNum;
		if(field_label){e.innerHTML = orig_name + ' &#10140; ' + field_label;e.value = num + ':' + field_label;}
		else{e.innerHTML=orig_name;e.value=num;}
		e.dataset.mapName=field_label;
	});
}

function get_field_label(){$('#field_label').val($('#selected_fields option:selected').get()[0].dataset.mapName||'');}
$('#button_move_up').click(function(){move_field('selected_fields',-1);});
$('#button_move_down').click(function(){move_field('selected_fields',1);});
$('#button_add').click(function(){add_selected_fields()});
$('#button_remove').click(function(){remove_selected_fields()});
$('#button_change').click(function(){change_field_name()});
$('#selected_fields').change(get_field_label);
if(dbid===3)$('#selected_fields #product-fields option').filter(function(){return this.value < 200}).appendTo('#order-fields');
});

function return_fieldmap()
{
	var selected_fields = document.getElementById('selected_fields'), fieldmap_name = document.getElementById('fieldmap_name'), map_fields = document.getElementById('map_fields'), names, check, saveas, empty, fields = '', i, n;

	// collect the selected fields for the field map
	n = selected_fields.options.length;
	if(n > 0)
	{
		for(i = 0; i < n; i++)
			fields += '|' + selected_fields.options[i].value;

		if(i > 0)
			fields = fields + '|';
	}

	// get the name that the field map should be saved as
	saveas = fieldmap_name.value;
	if(saveas.length == 0)
	{
		alert(enter_map_name);
		fieldmap_name.focus();
		return false;
	}

	// check for invalid characters in the name
	check = saveas.toLowerCase();
	if(/[^abcdefghijklmnopqrstuvwxyz0123456789._\- ]/.test(check))
	{
		alert(use_valid_characters + '\n' + valid_characters);
		fieldmap_name.focus();
		return false;
	}

	map_fields.value = fields;

	with(window.opener.document.forms[0])
	{
		i = fieldmap.options.selectedIndex;
		names = fieldmap.options;

		// check if fields were selected or removed for the field map
		if(fields.length > 0)
		{
			// check if saveas name is different
			if(names[i].value != saveas)
			{
				// look for a place to put the new or changed name
				n = fieldmap.options.length - 1;
				for(i = 0, empty = -1; i < n; i++)
				{
					// check if field map is replacing an existing one
					if(names[i].value == saveas)
					{
						empty = -1;
						break;
					}
					else if(names[i].value == '' && empty < 0)
						empty = i; // remember first empty slot
				}

				if(empty >= 0)
					i = empty;

				names[i].text = saveas;
				names[i].value = saveas;
				names[i].selected = true;
			}

			download_fields[2].checked = true;

		}
		else
		{
			// remove entry name for deleted field map
			names[i].text = '<' + new_entry + '>';
			names[i].value = '';
			names[i].selected = true;
		}
	}

	return true;
}

function confirm_delete_func()
{
	var proceed = false;
	var names, i;

	with(window.opener.document.forms[0])
	{
		names = fieldmap.options;
		i = fieldmap.options.selectedIndex;
		if(confirm('Are you sure you want to delete ' + names[i].text + '?'))
		{
			proceed = true;
			names[i].text = '<New>';
			names[i].value = '';
			names[i].selected = true;
		}
	}

	if(proceed)
	{
		// sending an empty list of fields will delete the field map
		document.forms[0].map_fields.value = '';
		return true;
	}

	return false;
}

function return_selected_fields()
{
	var fields = document.getElementById('selected_fields').options;
	var return_fields = '';
	var i;

	for(i = 0; i < fields.length; i++)
		return_fields += '|' + fields[i].value;

	if(i > 0)
		return_fields += '|';

	with(window.opener.document.forms[0])
	{
		selected_fields.value = return_fields;
		download_fields[selected_fields_option].checked = true;
	}

	window.close();
}
