"use_strict";
function trim_filename(name)
{
  if (name.length > 0) {
		// replace invalid characters with hyphen
		name = name.replace(/[^a-zA-Z0-9\-._]/g, '-');
    // replace multiple hyphens with a single hyphen
    //name = name.replace(/--+/g, '-');
    // replace multiple underscores with a single underscore
    //name = name.replace(/__+/g, '_');
    // replace multiple periods with a single period
    name = name.replace(/\.\.+/g, '.');
    // replace multiple hyphen, underscores, or periods with a single hyphen
    //name = name.replace(/[\-_.][\-_.]+/g, '-');
    // trim leading and trailing underscores, hyphens, spaces, and periods
    //name = name.replace(/^[_\-\. ]*|[_\-\. ]*$/g, '');
    name = name.replace(/^[\.]+|[\.]+$/g, '');
  }
  return name;
}
function unallowed_filename_chars(name){return name.match(/(^[\.]+|[\.]+$|[^a-zA-Z0-9\-._])/g) != null;}
//function unallowed_filename_chars(name){return name.match(/(^[_\-\. ]+|[_\-\. ]+$|[\-_.]{2,}|[^a-zA-Z0-9\-._])/g) != null;}
