function flip_publish() {
	var html = '<a href="generate.cgi" target="_top" >Publish<span> Changes</span></a>';
	$('#nav_publish').html(html);
}

ss_jQuery(function($) {
  var state = {
    rating: 0
  }

  var status_matrix = {
    'approve': {status: 'Approved', link: 'Approved', classes: 'green', clickers: ['promote_positive', 'promote_negative', 'disapprove']},
    'disapprove': {status: 'Disapproved', link: 'Disapproved', classes: 'red', clickers: ['approve', 'promote_positive', 'promote_negative']},
    'promote_positive': {status: 'Featured, positive', link: 'Featured, positive', classes: 'green bold', clickers: ['approve', 'disapprove', 'promote_negative']},
    'promote_negative': {status: 'Featured, negative', link: 'Featured, negative', classes: 'green bold', clickers: ['approve', 'disapprove', 'promote_positive']}
  }

  function post_response(id,content,async) {
    $.ajax({
      async:async,
      type: 'POST',
      url: 'reviews_bo.cgi',
      data: 'ajax=save_response&id='+id+'&response='+encodeURIComponent(content)
    });
  }

  $(document).on('click', '.response_link', function() {
    var p = $(this).closest('td');
    var id = p.next().find('.review_id').val();

    if ($(this).hasClass('write')) {
      var html =
      '<div class="response_edit_block"><textarea class="response_text" style="width:'+p.width()+'px;" placeholder="You can use HTML"></textarea>'+
        '<br><a class="response_link save">Save response</a><a class="response_link cancel">Cancel</a></div>';
      $(this).closest('.response_edit_clickers').before(html);
      $(this).closest('.response_edit_clickers').css({'display':'none'});

    }

    if ($(this).hasClass('cancel')) {
      p.find('.response_edit_clickers, .response_content').css({'display':''});
      $(this).closest('.response_edit_block').remove();
    }

    if ($(this).hasClass('save')) {
      var content = $(this).closest('.response_edit_block').find('.response_text').val();
      var html =
      '<b>Your response:</b><div class="response_content">'+content+'</div>';
      p.find('.response').html(html);
      //$(this).closest('.response_edit_block').replaceWith(html);
      p.find('.response_edit_clickers').html('<a class="response_link edit">Edit</a><a class="response_link remove">Remove</a>').css({'display':''});
      $(this).closest('.response_edit_block').remove();
      post_response(id, content, true);
      flip_publish();
    }

    if ($(this).hasClass('edit')) {
      var html =
      '<div class="response_edit_block"><textarea class="response_text" style="width:'+p.width()+'px;">'+p.find('.response_content').html()+'</textarea>'+
        '<br><a class="response_link save">Save response</a><a class="response_link cancel">Cancel</a></div>';
      $(this).closest('.response_edit_clickers').before(html);
      p.find('.response_edit_clickers, .response_content').css({'display':'none'});
    }

    if ($(this).hasClass('remove')) {
      if (confirm('Delete your response permanently?')) {
        p.find('.response').html('');
        p.find('.response_edit_clickers').html('<a class="response_link write">Write a response</a>');

        $.ajax({
          type: 'POST',
          url: 'reviews_bo.cgi',
          data: 'ajax=remove_response&id='+id
        });
        flip_publish();
      }

    }

  });

  $(document).one('click', '#button_done', function() {
    $('.response_edit_block').each(function() {
      var id = $(this).closest('td').next().find('.review_id').val();
      var content = $(this).find('.response_text').val();
      post_response(id, content, false);
    });
  });

  $('.decision_link').on('click',function() {

    var mass = false;
    var message = '';

    var decision='approve';
    if ($(this).hasClass('disapprove'))
      decision = 'disapprove';
    if ($(this).hasClass('promote_positive'))
      decision = 'promote_positive';
    if ($(this).hasClass('promote_negative'))
      decision = 'promote_negative';
    if ($(this).hasClass('demote'))
      decision = 'demote';
    if ($(this).hasClass('delete'))
      decision = 'delete';

    if ($(this).hasClass('disapprove_all')) {
      decision = 'disapprove_all';
      mass = true;
      message = 'All reviews disapproved';
    }

    if ($(this).hasClass('approve_all')) {
      decision = 'approve_all';
      mass = true;
      message = 'All reviews approved';
    }

    if (mass) {
      var data = 'ajax=1&decision='+decision;
      $('#all_reviews').replaceWith('<p class=reviews_message>' + message + '</p>');
      $(this).closest('.button_block').remove();
    } else {
      if (decision == 'delete')
        if (!confirm('Delete this review permanently?'))
          return;
        if (operation == 0 || decision == 'delete')
          $(this).closest('tr').remove();
        else {
          var status = $(this).parent().find('.status');
          $(status).html(status_matrix[decision].status);
          $(status).removeClass('green red bold').addClass(status_matrix[decision].classes);
          $(this).parent().find('.decision_link').addClass('hidden');
          for (var d in status_matrix[decision].clickers) {
            var clicker = $(this).parent().find('.'+status_matrix[decision].clickers[d]);
            $(clicker).removeClass('hidden');
            $(clicker).html(status_matrix[status_matrix[decision].clickers[d]].link);
          }
          $(this).parent().find('.delete').removeClass('hidden');
        }
        var id = $(this).parent().find('.review_id').val();
        var data = 'ajax=1&decision='+decision+'&id='+id;
    }
    //alert(data);
    $.ajax({
      type: 'POST',
      url: 'reviews_bo.cgi',
      data: data,
      success:  function(response) {
        flip_publish();
      }
    });
  });

  $('.reviews_area').bind('paste keydown', function() {
    var text = $(this).val();
    var len = text.length;
    if (len > max_length) {
      $(this).val(text.substr(0, max_length));
      len = max_length;
    }
    $(this).nextAll('.character_count').find('a').html(max_length - len);
  });
});
