function SetupContactManagers(ctct_sl, mc_sl){
	const fp1=$('[name=form_parm1]').val(),callback=function(button,check, get_lists){
		return function(good){
			if(good){
				let e=$('.access-granted', button.parent()),x=e.data('other');
				e.data('value', true).data('other',e.text()).text(x).removeClass('red').addClass('green');
				get_lists();
			}
			clearInterval(check);
			window.ConnectCallback=null;
		}
	};
	$.ajaxSetup({
		url: 'ctct.cgi',
		type: 'POST',
		dataType: 'json',
		//jsonp: 'callback',
		timeout: 10000
	});
	function ctct_get_lists() {
		var l = $('#ctct_loading_gif'), s = $('#ctct_list'), e = $('#ctct_list_error');
		e.hide().html('');
		s.html('<option value="">Select list...</option>');
		if(!$('#ctct-connect + .access-granted').data('value'))
			return;
		l.show();
		$.ajax({
			data:{GetList:'1',form_parm1:fp1},
			success:function(data){
				var c=data.contact_lists||[];
				c.forEach(function(l){$('<option />',{value:l.id}).text(l.name).prop('selected',l.id === ctct_sl || c.length === 1).appendTo(s);});
				if(data.error){e.text(data.error).show()}
				l.hide();
			},
			error: function(xr, er) {
				var e = $('#ctct_list_error');
				e.html('');
				if (er == 'timeout')
					e.append('The request timed out.');
				else if (xr.status == 200)
					e.append(er + '<br>');
				else
					e.append(xr.status + ' ' + xr.statusText + '<br>');
				e.show();
				l.hide();
			}
		});
	}
	ctct_get_lists();
	$('#ctct_list').change(function(){ctct_sl = this.value;});
	$('#ctct-connect').click(function(e){
		let button=$(e.target);
		window.open('ctct.cgi?ajax=ctct-connect', 'ctctConnect',"resizable=yes,scrollbars=yes,width=775,height=850");
		var f=function(){
			$.ajax({
				type:'POST',
				dataType:'json',
				jsonp:null,
				data:{ajax:'ctct-check',form_parm1:$('[name=form_parm1]').val()},
				success:function(data){if(data.working){}else{clearInterval(check);}},
				error:function(a){}
			});
		},check=window.setInterval(f, 60000);
		window.ConnectCallback=callback(button,check,ctct_get_lists);
	});

	if(typeof(mc_sl) === 'string'){
		//Mailchimp
		function mc_get_lists() {
			var s=$('#mailchimp_list'),l=$('#mc_loading_gif'),e=$('#mc_list_error');
			e.hide().html('');
			s.html('<option value="">Select list...</option>');
			if(!$('#mailchimp-connect + .access-granted').data('value'))
				return;
			l.show();
			$.ajax({data:{GetList:'2',form_parm1:fp1},
				success:function(data){
					var c=data.contact_lists||[];
					c.forEach(function(l){$('<option />',{value:l.id}).text(l.name).prop('selected',l.id === ctct_sl || c.length === 1).appendTo(s);});
					if(data.error){e.text(data.error.title).show()}
					l.hide();
				},
				error:function(xr,er){
					var e = $('#mc_list_error');
					e.html('');
					if(er == 'timeout')
						e.append('The request timed out.');
					else if(xr.status == 200)
						e.append('There was an error. Error: ' + er + '<br>');
					else
						e.append('There was a request error. Error: ' + xr.status + ' ' + xr.statusText + '<br>');
					e.show();
					l.hide();
				}
			});
		}
		mc_get_lists();
		$('#mailchimp_list').change(function(){mc_sl = this.value;});
		$('#mailchimp-connect').click(function(e){
			let button=$(e.target);
			window.open('ctct.cgi?ajax=mailchimp-connect', 'ctctConnect',"resizable=yes,scrollbars=yes,width=775,height=840");
			var f=function(){
				$.ajax({
					dataType:'json',
					jsonp:null,
					data:{ajax:'mailchimp-check',form_parm1:$('[name=form_parm1]').val()},
					success:function(data){if(data.working){}else{clearInterval(check);}},
					error:function(a){}
				});
			},check=window.setInterval(f, 60000);
			window.ConnectCallback=callback(button,check,mc_get_lists);
		});
	}
	$('[name=contact_manager]').each(function(){
		var t=$(this);
		if(t.val()!=0)t.addClass('cm_enabled');
	});
	$('[name=contact_manager]').on('change', function(){
		var v=$('[name=contact_manager]:checked').val();
		$('.cm_settings').hide();
		if(v==1){
			$('.ctct_section').show();
		}
		else if(v==2){
			$('.mailchimp_section').show();
		}
	}).change();
	$('#config_form').validate({
		rules:{
			sb_email_list_text:{required:'#sb_email_list:checked'},
			mailchimp_api_key:{required:'#contact_manager-2:checked'},
			mailchimp_list:{required:'#contact_manager-2:checked'},
			ctct_list:{required:'#contact_manager-1:checked'}
		},
		errorPlacement:function(e,l){
			l.parent().append(e);
		}
	});
};
