
var xmlHttp = null;
var pbar_num = 0;
var pbar_count = 0;
var pbar_percent = 0;

function GetXmlHttpObject()
{
  try
  {
    xmlHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    try
    {
      xmlHttp = new ActiveXObject("MSXML2.XMLHTTP");
    }
    catch(e)
    {
      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
  }

  return xmlHttp;
}

function get_pbar_percent()
{
  var url = pbar_url + '?sid=' + Math.random();

  xmlHttp = GetXmlHttpObject();
  xmlHttp.onreadystatechange = set_pbar_percent;
  xmlHttp.open("GET", url, false); // synchronous
  xmlHttp.send(null);
}

function set_pbar_percent()
{
  if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
  {
    if (xmlHttp.status == 200)
    {
      var response = xmlHttp.responseText;
      var parts = response.split(':');

      if (parts[0] == 'pbar')
      {
        var percent = Number(parts[1]);
        var pbar = (parts[2] == 'L')? 2 : 1;

        switch (parts[2])
        {
          case 'U':   // updating pages and products
            pbar = 1;
            break;

          case 'L':   // linking pages and products
            pbar = 2;
            break;

          case 'S':   // sorting page/product links on pages
            pbar = 3;
            break;

          default:
            return;
        }
        
        if (pbar_num == 0)
        {
          selectProgressBar(pbar);
          pbar_num = pbar;
          pbar_percent = 0;
        }
        else
        if (pbar != pbar_num)
        {
          setCount(100);
          selectProgressBar(pbar);
          pbar_num = pbar;
          pbar_percent = 0;
        }

        if (pbar_percent < percent)
        {
          setCount(percent);
          pbar_percent = percent;
          pbar_count = 0;
        }
        else
        if (pbar_count >= 10)
        {
          pbar_count = 0;
          pbar_percent++;
          setCount(pbar_percent);
        }
        else
          pbar_count++;
      }
    }
  }
}

