
function qbitem(func, field, row)
{
  var item_name = field + ":o_item_name:" + row;
  var item_desc = field + ":o_item_desc:" + row;
  var item_qbid = field + ":o_item_qbid:" + row;

  return func(get_option_name(field, row), item_name, item_desc, item_qbid);
}

function get_option_name(field, row)
{
  var num_columns = parseInt(document.getElementsByName(field + ":col_cnt")[0].value),option_name = "";

  for (col = 1; col <= num_columns; col++)
  {
    var column = document.getElementsByName(field + ":c" + col + ":" + row)[0];

    if (column != undefined)
    {
      if (option_name.length > 0)
        option_name += " " + column.value;
      else
        option_name = column.value;
    }
    else
      break;
  }

  var text = document.getElementsByName(field + ':o_str:' + row)[0];

  if (text != undefined)
  {
    if (option_name.length > 0)
      option_name += " " + text.value;
    else
      option_name = text.value;
  }

  return option_name;
}

function select_product_qbitem(product_name, item_name, item_desc, item_qbid)
{
  var url = pier_imports + '/products.cgi?qbimport_popup=0&product_name=';

  url += encodeURIComponent(product_name);
  url += '&item_name=' + item_name;
  url += '&item_desc=' + item_desc;
  url += '&item_qbid=' + item_qbid;

  window.open(url, 'qbitems', 'width=750,height=620,scrollbars=yes,resizable=yes');
  return false;
}

function select_option_qbitem(option_name, item_name, item_desc, item_qbid)
{
  var url = pier_imports + '/products.cgi?qbimport_popup=1&option_name=';

  url += encodeURIComponent(option_name);
  url += '&item_name=' + item_name;
  url += '&item_desc=' + item_desc;
  url += '&item_qbid=' + item_qbid;

  window.open(url, 'qbitems', 'width=750,height=620,scrollbars=yes,resizable=yes');
  return false;
}

function edit_qbitem(option_name, item_name, item_desc, item_qbid)
{
  var popup = document.getElementById(item_name).value.length == 0? '2' : '3';  // 2 is add, 3 is edit
  var url = pier_imports + '/products.cgi?qbimport_popup=' + popup;

  url += '&option_name=' + encodeURIComponent(option_name);
  url += '&item_name=' + item_name;
  url += '&item_desc=' + item_desc;
  url += '&item_qbid=' + item_qbid;

  window.open(url, 'qbitems', 'width=850,height=350,scrollbars=yes,resizable=yes');
  return false;
}

function return_qbitem()
{
  var item_names = document.getElementById('item_names');
  var item_descs = document.getElementById('item_descs');
  var item_name, item_desc, item_qbid;
  var i;

  if ((i = item_names.selectedIndex) >= 0)
  {
    item_name = item_names.options[i].text;
    item_qbid = item_names.options[i].value;
    item_desc = item_descs.options[i].value;
  }
  else
  {
    alert(qbitem_select_name);
    return false;
  }

  window.opener.document.getElementById(qbitem_name).value = item_name;
  window.opener.document.getElementById(qbitem_desc).value = item_desc;
  window.opener.document.getElementById(qbitem_qbid).value = item_qbid;
  window.close();
}

function save_qbitem()
{
  var item_name = document.getElementById('item_name');
  var item_desc = document.getElementById('item_desc');
  var item_qbid = document.getElementById('item_qbid');

  if (item_name.value.length == 0)
  {
    alert(qbitem_name_required);
    item_name.focus();
    return;
  }

  window.opener.document.getElementById(qbitem_name).value = item_name.value;
  window.opener.document.getElementById(qbitem_desc).value = item_desc.value;
  window.opener.document.getElementById(qbitem_qbid).value = item_qbid.value;
  window.close();
}

function remove_qbitem()
{
  window.opener.document.getElementById(qbitem_name).value = '';
  window.opener.document.getElementById(qbitem_desc).value = '';
  window.opener.document.getElementById(qbitem_qbid).value = '';
  window.close();
}

function show_instructions()
{
  var url = pier_imports + '/products.cgi?qbimport_instructions=1';
  window.open(url, 'qbimport', 'width=620,height=300,scrollbars=yes,resizable=yes');
  return false;
}

