"use_strict";
function CoverElement(e){let p=$(e).parent().css('display'),c={'position':'relative'};if(p != 'block' && p != 'inline-block'){c['display']='inline-block'}$(e).before('<div class="ss-cover"></div>').parent().css(c);}

function set_cookie(name, value, expirationDays){
	let cookie = name + '=' + value;
	if(document.location.protocol === 'https:'){cookie += ';SameSite=None;Secure;';}else{cookie += ';SameSite=Lax;';}
	if(Number.isInteger(expirationDays)){cookie += 'Max-Age='+(expirationDays*86400);}
	document.cookie = cookie;
}

function get_cookie(c_name){
	let cookies={};
	document.cookie.split(';').forEach(function(t){let n=t.replace(/^\s+/,'').split('=');cookies[n[0]]=n[1];});
	return cookies[c_name];
}

function ss_alert(message){
	$.modal('<div id="ss-alert-message">'+message+'</div><div class="button cancel" id="close-alert">Close</div>',
		{
			closeHTML:'',
			autoResize:true,
			minWidth:440,
			overlayClose:false,
			onClose:function(){$.modal.close();$('body').css({'overflow':''});}
		});
		$('body').css({'overflow':'hidden'});
		$('#close-alert').click(function(){$.modal.close();$('body').css({'overflow':''});});
}
//loadmask
var loadmaskphrase;
function ss_loadmask(state, message){if(state === 'on') {if($('#ss-loadmask-overlay').length === 0) {$('<div></div>').text(message || loadmaskphrase || 'Processing...').appendTo('body').wrap('<div id="ss-loadmask-overlay"></div>').wrap('<div id="ss-loadmask-content"></div>');}}else{$('#ss-loadmask-overlay').remove();}}

//Floating save buttons
function adjustFloater(){let onscreen=this.onscreen||0,buffer=this.buffer||150,isOnScreen=(function(elem){return(elem.offset().top+elem.height())<=($(window).scrollTop()+$(window).height())+buffer;})($('#footer'));if (onscreen == 0 && isOnScreen) {$('.floater').removeClass('floater').addClass('defloater');this.onscreen=1;this.buffer=300;}else if(onscreen == 1 && !isOnScreen) {$('.defloater').removeClass('defloater').addClass('floater');this.onscreen=0;this.buffer=150;}}

$(function($){
	//Floating buttons
	if($('.floater').length > 0) {
		adjustFloater();
		$(window).on('scroll',adjustFloater);
	}

	//Collapsible
	if ($('h2.collapsible').length) {
		//Collapsible
		let open_section_list=[], collapsible_cookie={}, current_cgi, collapsible_save_state=true;

		window.ss_collapsible={
			toggle_section:function(a, setc){let b = $(a).next().next();if(b.is(':hidden')){funcs.show_section(b,setc)}else{funcs.hide_section(b,setc)}adjustFloater();},
			show_section:function(b, setc, all){let generated_id = b.prev().prev()[0].dataset.collapsibleId;if(!all&&$('div.collapsible:visible').length === 0){$('.sections_global').toggle();}b.prev('.collapsible.explanation').show();b.show().prev().prev().find('.section_collapse_toggle').html('&ndash;');if (!open_section_list.includes(generated_id)){open_section_list.push(generated_id)}if (setc){funcs.set_collapsible_cookie()}},
			hide_section:function(b, setc, all){let generated_id = b.prev().prev()[0].dataset.collapsibleId, index;b.prev('.collapsible.explanation').hide();b.hide().prev().prev().find('.section_collapse_toggle').html('&plus;');if((index=open_section_list.indexOf(generated_id))!=-1){open_section_list.splice(index,1)}if(setc){funcs.set_collapsible_cookie()}if(!all&&$('div.collapsible:visible').length === 0){$('.sections_global').toggle();}},
			hide_show_all:function(hide_show_func){return function(){$('h2.section_head.collapsible').each(function(index){hide_show_func($(this).next().next(),false,true)});funcs.set_collapsible_cookie();$('.sections_global').toggle();adjustFloater();};},
			set_collapsible_cookie:function(){if(collapsible_save_state){collapsible_cookie[current_cgi]=open_section_list;let cookie=JSON.stringify(collapsible_cookie);set_cookie('collapsible_sections',cookie,365);}}
		};

		let use_defaults = 0, funcs=window.ss_collapsible;;
		current_cgi = window.location.href.match(/([^\/]+)\.cgi/i)[1]+'-'+document.body.id.replace('body_','');

		if(collapsible_save_state){collapsible_cookie = get_cookie('collapsible_sections');}
		if (!collapsible_cookie) {
			collapsible_cookie = {};
			use_defaults = 1;
			collapsible_cookie[current_cgi] = [];
		} else if(/^body_(power_edit|add_multiple|themes_layout)/.test($('body').attr('id'))) {
			collapsible_cookie = {};
			use_defaults = 2;
			collapsible_cookie[current_cgi] = [];
		} else {
			collapsible_cookie = JSON.parse(collapsible_cookie);
			if (!collapsible_cookie.hasOwnProperty(current_cgi)) {
				use_defaults = 1;
				collapsible_cookie[current_cgi] = [];
			}
		}

		if (!use_defaults){open_section_list = collapsible_cookie[current_cgi];}
		$('h2.collapsible').append($('<span class="section_collapse_toggle noSelect">&plus;</span>')).on('click',function(){funcs.toggle_section(this, true)});
		$('h2.section_head.collapsible a').css({'float':'left'});

		let opened_count = 0, count = 0;

		$('h2.collapsible').each(function (index) {
			this.dataset.collapsibleId=''+(++count);
			if ($(this).prop('id').length === 0) {
				$(this).prop('id',$(this).find('a').prop('name').trim().toLowerCase().replace(/ /g, '_').replace(/<(?:.|\n)*?>/gm, '').replace(/\W/g, '')+'_gen_id');
			}

			if ((use_defaults && $(this).hasClass('col_def_open')) || (open_section_list.indexOf(this.dataset.collapsibleId) != -1)) {
				funcs.toggle_section(this, false);
				opened_count++;
			}
		});

		collapsible_cookie[current_cgi] = open_section_list;
		if (use_defaults === 1) {funcs.set_collapsible_cookie()}

		if(!(['body_theme_layouts','body_payment_options'].includes(document.body.id))&&$('h2.collapsible').length > 1) {
			$('.config_table:first').before($('#collapse-template').html());
			$('#collapse_'+(opened_count>0?'hide':'show')).show();
			$(document).on('click', '.all-hide', funcs.hide_show_all(funcs.hide_section));
			$(document).on('click', '.all-show', funcs.hide_show_all(funcs.show_section));
		}
	}
	//Resize number input fields
	$('[type="number"][size]').each(function(){let t=$(this),e=$('<input type="text">').attr('size',t.attr('size')).css('display','none').insertAfter(t);t.width(e.width());e.remove();});
	$('[type="number"]').on('scroll',function(e){e.preventDefault()});
	//Block double-click forms
	$(document).on('submit','form', function(e){if(this.dataset.blocked){e.preventDefault();console.log('blocked double click');}else if(!this.dataset.noBlock){var t=this;this.dataset.blocked='true';setTimeout(function(){t.dataset.blocked=''},1000);}});
	//Dark theme
	if(document.body.dataset&&document.body.dataset.systemFlag!==undefined){if(window.matchMedia&&window.matchMedia('(prefers-color-scheme)')){let f=function(x){set_cookie('bo_theme',x);document.body.className=x;},x=window.matchMedia('(prefers-color-scheme:dark)').matches&&'dark'||'light';window.matchMedia('(prefers-color-scheme:dark)').addEventListener('change',function(e){console.log(e.target.matches);f(e.target.matches&&'dark'||'light');});f(x);}}
	//auto select
	$('input[type="text"][readonly],textarea[readonly],.select-onclick').on('click',function(e){if(!$(this).hasClass('fake_input')){e.preventDefault();$(this).blur().focus().select();this.setSelectionRange(0,99999);}else{this.blur()}});
	//Copy Text
	$('.copyText.button').on('click', function(e){e.preventDefault();e.stopPropagation();let t=this,x=document.getElementById(t.dataset.element), text=t.dataset.copied;if(t.dataset.started){return false;}t.dataset.started=true;x.select();if(x.setSelectionRange)x.setSelectionRange(0,99999);document.execCommand("copy");if(t.dataset.oldText == undefined)t.dataset.oldText=t.innerText;t.innerText=text;setTimeout(function(){t.innerText=t.dataset.oldText;t.dataset.started=false;},4000);});
	$('#nav_logo_level').click(function(e){e.preventDefault();window.open(this.dataset.url,'feature-comparison','width=800,height=400,resizable=yes,scrollbars=yes');});
});
